
include ../.config

PKG:=busybox
VERSION:=1.2.1
DIR:=${PKG}-${VERSION}
BUSYBOX_LINKS=`xargs < ${DIR}/busybox.links`
TESTSUITE=${ROOT}/examples/busybox-testsuite

.PHONY: all
all: build install

.PHONY: build
build: ${DIR}
	${MAKE} -C ${DIR} EXTRA_CFLAGS="${TOOLCHAIN_ABI}" LDFLAGS=""

.PHONY: install
install: ${DIR}
	mkdir -p ${ROOT}/bin
	mkdir -p ${ROOT}/sbin
	mkdir -p ${ROOT}/usr/bin
	mkdir -p ${ROOT}/usr/sbin
	mkdir -p ${ROOT}/usr/include
	mkdir -p ${ROOT}/usr/local/bin
	mkdir -p ${ROOT}/usr/local/sbin
	mkdir -p ${ROOT}/usr/local/man
	mkdir -p ${ROOT}/usr/local/share/snmp
	mkdir -p ${ROOT}/usr/local/include
	mkdir -p ${ROOT}/usr/local/lib/
	mkdir -p ${ROOT}/usr/local/lib/snmp
	mkdir -p ${ROOT}/usr/local/lib/snmp/dlmod
	mkdir -p ${ROOT}/usr/lib/ebtables
	mkdir -p ${ROOT}/proc
	mkdir -p ${ROOT}/proc/modules
	mkdir -p ${ROOT}/sys
	mkdir -p ${ROOT}/mnt
	mkdir -p ${ROOT}/tmp
	mkdir -p ${ROOT}/var
	mkdir -p ${ROOT}/var/log
	mkdir -p ${ROOT}/etc
	mkdir -p ${ROOT}/etc/init.d
	mkdir -p ${ROOT}/etc/dropbear
	mkdir -p ${ROOT}/etc/default
	mkdir -p ${ROOT}/etc/rc.d
	mkdir -p ${ROOT}/etc/rc.d/init.d
	mkdir -p ${ROOT}/etc/sysconfig
	mkdir -p ${ROOT}/root
	mkdir -p ${ROOT}/lib/modules
	mkdir -p ${ROOT}/home
	mkdir -p ${ROOT}/home/www
	mkdir -p ${ROOT}/home/admin
	${STRIP} -o ${ROOT}/bin/busybox ${DIR}/busybox
	for link in ${BUSYBOX_LINKS}; do ln -s /bin/busybox ${ROOT}$$link; done
	# The following link is needed for initramfs based boots
	ln -s /sbin/init ${ROOT}/init
	cp ${SOURCE_DIR}/cpu-load ${ROOT}/usr/bin/
ifdef CFG_BUSYBOX_TESTSUITE
	mkdir -p ${ROOT}/examples
	cp ${DIR}/.config ${ROOT}/examples/
	cp -R ${DIR}/testsuite ${TESTSUITE}
	cp ${SOURCE_DIR}/busybox-runtest ${TESTSUITE}/runtest
	rm -r ${TESTSUITE}/bunzip2				# No bzip2 available
	rm -r ${TESTSUITE}/du					# Doesn't test anything
	rm -r ${TESTSUITE}/wget					# Networking may not be up
	rm ${TESTSUITE}/cp/cp-a-files-to-dir 			# Unsupported touch option
	rm ${TESTSUITE}/cp/cp-does-not-copy-unreadable-file 	# Doesn't work because root can read
	rm ${TESTSUITE}/mv/mv-files-to-dir			# Unsupported touch option
	rm ${TESTSUITE}/mv/mv-refuses-mv-dir-to-subdir		# Unsupported touch option
	rm ${TESTSUITE}/touch/touch-touches-files-after-non-existent-file			# touch -t doesn't work
	sed -i "s:../../busybox:/bin/busybox:g" ${TESTSUITE}/strings/strings-works-like-GNU	# Fix busybox path
	sed -i "s:BUSYBOX=.*:BUSYBOX=/bin/busybox:" ${TESTSUITE}/which/which-uses-default-path	# Fix busybox path
endif	

${DIR}:
	tar -jxf ${STORAGE}/${PKG}-${VERSION}.tar.bz2
	cd ${DIR} && patch -p0 < ${STORAGE}/busybox-udhcpcd-64bit.patch
	cp ${STORAGE}/busybox.config ${DIR}/.config
#copy modified files into build/busybox-1.2.1 from storage/busybox-1.2.1
	cp ${STORAGE}/${DIR}/src-patch/applets.h  ${DIR}/include/applets.h
	cp ${STORAGE}/${DIR}/src-patch/Config.in  ${DIR}/coreutils/Config.in
	cp ${STORAGE}/${DIR}/src-patch/full_write.c	 ${DIR}/libbb/full_write.c
	cp ${STORAGE}/${DIR}/src-patch/libbb.h	${DIR}/include/libbb.h
	cp ${STORAGE}/${DIR}/src-patch/llist.c	 ${DIR}/libbb/llist.c
	cp ${STORAGE}/${DIR}/src-patch/Makefile.in	${DIR}/coreutils/Makefile.in
	cp ${STORAGE}/${DIR}/src-patch/usage.h	${DIR}/include/usage.h
	cp ${STORAGE}/${DIR}/src-patch/wfopen_input.c ${DIR}/libbb/wfopen_input.c
	cp ${STORAGE}/${DIR}/src-patch/xfuncs.c ${DIR}/libbb/xfuncs.c
	cp ${STORAGE}/${DIR}/src-patch/tac.c	${DIR}/coreutils/tac.c



ifdef CFG_ENABLE_IPV6	
	sed -i "s/# CONFIG_FEATURE_IPV6 is not set/CONFIG_FEATURE_IPV6=y/" ${DIR}/.config
	sed -i "s/# CONFIG_PING6 is not set/CONFIG_PING6=y/" ${DIR}/.config
	sed -i "s/# CONFIG_FEATURE_FANCY_PING6 is not set/CONFIG_FEATURE_FANCY_PING6=y/" ${DIR}/.config
endif
	${MAKE} -C ${DIR} oldconfig > /dev/null
	
