include ../.config

PKG:=strace
VERSION:=4.5.14
DIR:=${PKG}-${VERSION}

.PHONY: all
all: build install

.PHONY: build
build: ${DIR} ${DIR}/Makefile
ifdef TOOLCHAIN_UCLIBC
	sed -i "s/#define HAVE_STROPTS_H 1/\/\/#define HAVE_STROPTS_H/g" ${DIR}/config.h
endif
	${MAKE} -C ${DIR}
	
${DIR}/Makefile:
	cd ${DIR} && ./configure --host=${CROSS} CFLAGS="${CFLAGS}" LDFLAGS="${TOOLCHAIN_ABI}"

.PHONY: install
install: ${DIR}
	mkdir -p ${ROOT}/usr/bin
	${STRIP} -o ${ROOT}/usr/bin/strace ${DIR}/strace

${DIR}:
	tar -jxf ${STORAGE}/${PKG}-${VERSION}.tar.bz2
	cd ${DIR} && patch -p0 < ${STORAGE}/strace.patch
	
