


typedef struct bridge_info{
	u_char macaddr[6];
	u_long numports;
	u_long base_type;	
	u_long prot_spec;		/*protocol Specification*/
	u_long priority;		/*Stp Priority*/
	u_long time_since_tp_ch;	/*Time Since Topology change */
	u_long tp_count;		/*Total No. of topology change*/
	u_char brdg_id[8];		/*Bridge ID*/
	u_char designated_root[8];
	u_long root_cost;
	u_long root_port;	
	u_long max_age;			/*unit Timeout*/
	u_long hello_time;
	u_long hold_time;
	u_long fwrd_delay;
	u_long brmax_age;		/*unit Timeout*/
	u_long brhello_time;
	u_long brfwrd_delay;
	u_long entry_discard;
	u_long ageing_time;
	}bridge_info;

typedef struct base_port_table{
	u_long port_idx;
	u_long ifindex;
	u_char circuit[4];		/*It is always 0.0.0*/
	u_long delay_excd_discard;
	u_long mtu_excd_discard;
	struct base_port_table *next;
	}base_port;

typedef struct stp_port_table{
	u_long port_idx;
	u_long priority;
	u_long state;
	u_long enable;
	u_long path_cost;
	u_char designated_root[8];
	u_long designated_cost;
	u_char bridge_id[8];
	u_char designated_port[2];
	u_long frwd_transition;
	struct stp_port_table *next;
	}stp_port;

typedef struct dtp_fdb_table{
	u_char macaddr[6];
	u_long port;
	u_long status;
	struct dtp_fdb_table *next;
	}dtp_fdb;

typedef struct dtp_port_table{
	u_long port_idx;
	u_long max_info;
	u_long inframes;
	u_long outframes;
	u_long discard;
	}dtp_port;

extern int brdg_info(bridge_info *br_info);
extern int base_port_table (base_port **head);
extern int stp_port_table (stp_port **head);
extern int dtpfdp_table(dtp_fdb **head);
