#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "Trap.h"


oid snmpobj_oid[]	= {1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0};

oid rogue_oid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 1};
oid rogue_mac []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 1, 0};
oid rogue_ssid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 2, 0};
oid rogue_prv []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 3, 0};
oid rogue_band []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 4, 0};
oid rogue_ch []		= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 5, 0};
oid rogue_rate []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 6, 0};
oid rogue_beacon []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 7, 0};
oid rogue_numbeacon []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 8, 0};
oid rogue_lastbeacon [] = {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 1, 2, 9, 0};


oid max_oid []		= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 2, 1};
oid max_stationmac[]	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 2, 2, 1, 0};
oid max_stationband[]	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 2, 2, 2, 0};
	
oid acl_oid []		= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 3, 1};
oid acl_msmatchmac []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 3, 2, 1, 0};
oid acl_msmatchBSsid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 3, 2, 2, 0};
oid acl_msmatchSsid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 3, 2, 3, 0};

oid nobeacon_oid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 4, 1};
oid nobeacon_BSsid []	= {1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 17, 4, 2, 1, 0};

int
Send_Trap(Var_Trap trp)
{
	int i,val_len,oid_len,type,ret;
	oid *name;
	char *val;
	netsnmp_variable_list *varlist = NULL;
	for(i=0;i < trp.num_var;i++)
	{
		name = trp.ptr_list[i].name_oid;
		oid_len = trp.ptr_list[i].oid_len;
		type = trp.ptr_list[i].type;
		val = trp.ptr_list[i].val;
		val_len = trp.ptr_list[i].val_len;
		if(snmp_varlist_add_variable (&varlist,name,oid_len,type,val,val_len) == NULL)
		{
			snmp_log(LOG_ERR,"\nfailed\n");
			return 	FAILURE;
		}
	}
        printf("\n****************send to net-snmp utility****************\n");
	send_v2trap(varlist); 
		return FAILURE;
	snmp_log(LOG_ERR,"trap  2\n");
	snmp_free_varbind(varlist);
return SUCCESS;
}


int 
Trap_noBeacon_Req(bcon_Trap *trp)
{
	Var_Trap var;
	int ret;
	var.num_var = 2;
	var.ptr_list = (Ptr_VarList *)malloc(var.num_var * sizeof(Ptr_VarList));
	if(var.ptr_list == NULL)
	{
		snmp_log(LOG_ERR,"\nmalloc failed\n");
		return FAILURE;
	}

	var.ptr_list -> name_oid = snmpobj_oid;
	var.ptr_list -> oid_len = OID_LENGTH(snmpobj_oid);
	var.ptr_list -> type = ASN_OBJECT_ID;
	var.ptr_list -> val  = (u_char *) nobeacon_oid; 
	var.ptr_list -> val_len = OID_LENGTH(nobeacon_oid) * sizeof(oid);
	
	(var.ptr_list + 1) -> name_oid = nobeacon_BSsid;
	(var.ptr_list + 1) -> oid_len = OID_LENGTH(nobeacon_BSsid);
	(var.ptr_list + 1) -> type = ASN_OCTET_STR;
	(var.ptr_list + 1) -> val  = (u_char *)(trp->noBeaconBssid); 
	(var.ptr_list + 1) -> val_len = 6;
	
	snmp_log(LOG_ERR,"\n**************no beacon Send trap********** \n");
	ret = Send_Trap(var);
	free(var.ptr_list);
	return ret;
}
int 
Trap_Aclmismatch_Req(acl_Trap *trp)
{
	Var_Trap var;
	int ret;
	var.num_var = 4;
	var.ptr_list = (Ptr_VarList *)malloc(var.num_var * sizeof(Ptr_VarList));
	snmp_log(LOG_ERR,"\nTrap_Send\n");
	if(var.ptr_list == NULL)
	{
		snmp_log(LOG_ERR,"\nmalloc failed\n");
		return FAILURE;
	}

	var.ptr_list -> name_oid = snmpobj_oid;
	var.ptr_list -> oid_len = OID_LENGTH(snmpobj_oid);
	var.ptr_list -> type = ASN_OBJECT_ID;
	var.ptr_list -> val  = (u_char *)acl_oid; 
	var.ptr_list -> val_len = OID_LENGTH(acl_oid) * sizeof(oid);
	
	(var.ptr_list + 1) -> name_oid = acl_msmatchmac;
	(var.ptr_list + 1) -> oid_len = OID_LENGTH(acl_msmatchmac);
	(var.ptr_list + 1) -> type = ASN_OCTET_STR;
	(var.ptr_list + 1) -> val  = (u_char *)(trp->aclMsMatchMacAddr); 
	(var.ptr_list + 1) -> val_len = 6;
	
	(var.ptr_list + 2) -> name_oid = acl_msmatchBSsid;
	(var.ptr_list + 2) -> oid_len = OID_LENGTH(acl_msmatchBSsid);
	(var.ptr_list + 2) -> type = ASN_OCTET_STR;
	(var.ptr_list + 2) -> val = (u_char *)(trp->aclMsMatchBssid);
	(var.ptr_list + 2) -> val_len = 6;
	
	(var.ptr_list + 3) -> name_oid = acl_msmatchSsid;
	(var.ptr_list + 3) -> oid_len = OID_LENGTH(acl_msmatchSsid);
	(var.ptr_list + 3) -> type = ASN_OCTET_STR;
	(var.ptr_list + 3) -> val = (u_char *)(trp->aclMsMatchSsid);
	(var.ptr_list + 3) -> val_len = strlen(trp->aclMsMatchSsid);
        snmp_log(LOG_ERR,"\n****************AclMismatch Send Trap*************** \n");
	ret = Send_Trap(var);
	free(var.ptr_list);
	return ret;
}

int 
Trap_MaxStation_Req(stat_Trap *trp)
{
	Var_Trap var;
	int ret;
	var.num_var = 3;
	var.ptr_list = (Ptr_VarList *)malloc(var.num_var * sizeof(Ptr_VarList));
	if(var.ptr_list == NULL)
	{
		snmp_log(LOG_ERR,"\nmalloc failed\n");
		return FAILURE;
	}

	var.ptr_list -> name_oid = snmpobj_oid;
	var.ptr_list -> oid_len = OID_LENGTH(snmpobj_oid);
	var.ptr_list -> type = ASN_OBJECT_ID;
	var.ptr_list -> val  = (u_char *)max_oid; 
	var.ptr_list -> val_len = OID_LENGTH(max_oid) * sizeof(oid);
	
	(var.ptr_list + 1) -> name_oid = max_stationmac;
	(var.ptr_list + 1) -> oid_len = OID_LENGTH(max_stationmac);
	(var.ptr_list + 1) -> type = ASN_OCTET_STR;
	(var.ptr_list + 1) -> val  = (u_char *)(trp->maxStatMacAddr); 
	(var.ptr_list + 1) -> val_len = 6;
	
	(var.ptr_list + 2) -> name_oid = max_stationband;
	(var.ptr_list + 2) -> oid_len = OID_LENGTH(max_stationband);
	(var.ptr_list + 2) -> type = ASN_INTEGER;
	(var.ptr_list + 2) -> val = (u_char *)&(trp->maxStationBand);
	(var.ptr_list + 2) -> val_len = sizeof(int);
  	snmp_log(LOG_ERR,"\n **********************Max Station Trap_Send***************\n");	
	ret = Send_Trap(var);
	free(var.ptr_list);
	return ret;
}

int 
Trap_Rogue_Req(rogue_trap *trp)
{
	Var_Trap var;
	int ret;
	var.num_var = 10;
	var.ptr_list = (Ptr_VarList *)malloc(var.num_var * sizeof(Ptr_VarList));
	snmp_log(LOG_ERR,"\nTrap_Send\n");
	if(var.ptr_list == NULL)
	{
		snmp_log(LOG_ERR,"\nmalloc failed\n");
		return FAILURE;
	}

	var.ptr_list -> name_oid = snmpobj_oid;
	var.ptr_list -> oid_len = OID_LENGTH(snmpobj_oid);
	var.ptr_list -> type = ASN_OBJECT_ID;
	var.ptr_list -> val  = (u_char *)rogue_oid; 
	var.ptr_list -> val_len = OID_LENGTH(rogue_oid) * sizeof(oid);

	(var.ptr_list + 1) -> name_oid = rogue_mac;
	(var.ptr_list + 1) -> oid_len = OID_LENGTH(rogue_mac);
	(var.ptr_list + 1) -> type = ASN_OCTET_STR;
	(var.ptr_list + 1) -> val  = (u_char *)(trp->rogue_MacAddr); 
	(var.ptr_list + 1) -> val_len = 6;

	(var.ptr_list + 2) -> name_oid = rogue_ssid;
	(var.ptr_list + 2) -> oid_len = OID_LENGTH(rogue_ssid);
	(var.ptr_list + 2) -> type = ASN_OCTET_STR;
	(var.ptr_list + 2) -> val = (u_char *)(trp->rogue_Ssid);
	(var.ptr_list + 2) -> val_len = strlen(trp->rogue_Ssid);

	(var.ptr_list + 3) -> name_oid = rogue_prv;
	(var.ptr_list + 3) -> oid_len = OID_LENGTH(rogue_prv);
	(var.ptr_list + 3) -> type = ASN_INTEGER;
	(var.ptr_list + 3) -> val = (u_char *)&(trp->rogue_prv);
	(var.ptr_list + 3) -> val_len = sizeof(int);

	(var.ptr_list + 4) -> name_oid = rogue_band;
	(var.ptr_list + 4) -> oid_len = OID_LENGTH(rogue_band);
	(var.ptr_list + 4) -> type = ASN_INTEGER;
	(var.ptr_list + 4) -> val = (u_char *)&(trp->rogue_band);
	(var.ptr_list + 4) -> val_len = sizeof(int);

	(var.ptr_list + 5) -> name_oid = rogue_ch;
	(var.ptr_list + 5) -> oid_len = OID_LENGTH(rogue_ch);
	(var.ptr_list + 5) -> type = ASN_INTEGER;
	(var.ptr_list + 5) -> val = (u_char *)&(trp->rogue_ch);
	(var.ptr_list + 5) -> val_len = sizeof(int);

	(var.ptr_list + 6) -> name_oid = rogue_rate;
	(var.ptr_list + 6) -> oid_len = OID_LENGTH(rogue_rate);
	(var.ptr_list + 6) -> type = ASN_INTEGER;
	(var.ptr_list + 6) -> val = (u_char *)&(trp->rogue_rate);
	(var.ptr_list + 6) -> val_len = sizeof(int);

	(var.ptr_list + 7) -> name_oid = rogue_beacon;
	(var.ptr_list + 7) -> oid_len = OID_LENGTH(rogue_beacon);
	(var.ptr_list + 7) -> type = ASN_INTEGER;
	(var.ptr_list + 7) -> val = (u_char *)&(trp->rogue_beacon);
	(var.ptr_list + 7) -> val_len = sizeof(int);

	(var.ptr_list + 8) -> name_oid = rogue_numbeacon;
	(var.ptr_list + 8) -> oid_len = OID_LENGTH(rogue_numbeacon);
	(var.ptr_list + 8) -> type = ASN_INTEGER;
	(var.ptr_list + 8) -> val = (u_char *)&(trp->rogue_numbeacon);
	(var.ptr_list + 8) -> val_len = sizeof(int);

	
	(var.ptr_list + 9) -> name_oid = rogue_lastbeacon;
	(var.ptr_list + 9) -> oid_len = OID_LENGTH(rogue_lastbeacon);
	(var.ptr_list + 9) -> type = ASN_OCTET_STR;
	(var.ptr_list + 9) -> val = (u_char *)&(trp->rogue_lastbeacon);
	(var.ptr_list + 9) -> val_len = strlen(trp->rogue_lastbeacon);
        snmp_log(LOG_ERR,"\n******************Rogue AP Trap_Send******************\n");
	ret = Send_Trap(var);
	free(var.ptr_list);
	return ret;
}
	
