/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "logSettings.h"

logSettings node ;
char req_name[255],str[255];
int rv;

/*extern function for validating IP Address*/
extern long isValidIP(u_char*);

/*
 * logSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             logSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 13 };

/*
 * variable4 logSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the logSettings mib section 
 */

struct variable4 logSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define SYSLOGSTATUS		1
    {SYSLOGSTATUS, ASN_INTEGER, RWRITE, var_logSettings, 1, {1}},
#define SYSLOGSRVIP		2
    {SYSLOGSRVIP, ASN_IPADDRESS, RWRITE, var_logSettings, 1, {2}},
#define SYSLOGSRVPORT		3
    {SYSLOGSRVPORT, ASN_INTEGER, RWRITE, var_logSettings, 1, {3}},

};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the logSettings module */
void
init_logSettings(void)
{

    DEBUGMSGTL(("logSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("logSettings", logSettings_variables, variable4,
                 logSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_logSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_logSettings(struct variable *vp,
                oid * name,
                size_t *length,
                int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	char ret_buf[255];
        //memset(&node,0,sizeof(node));
	
    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

	sprintf(req_name,"system:logSettings:");

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case SYSLOGSTATUS:
        *write_method = write_syslogStatus;
	*var_len = sizeof(unsigned int);

	if( !db_get(req_name,"syslogStatus",ret_buf))
		node.syslog = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.syslog;
    case SYSLOGSRVIP:
        *write_method = write_syslogsrvip;
	*var_len = 4 ;

	if( !db_get(req_name,"syslogSrvIp",ret_buf))
		get_addr(node.syslogsrvip,ret_buf);
        else return NULL;
        return (u_char *) & node.syslogsrvip;
    case SYSLOGSRVPORT:
        *write_method = write_syslogsrvport;
	*var_len = sizeof(int);

	if( !db_get(req_name,"syslogSrvPort",ret_buf))
		node.syslogsrvport = atoi(ret_buf);
        else return NULL;
        return (u_char *) & node.syslogsrvport;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

int
write_syslogStatus(int action,
             u_char * var_val,
             u_char var_val_type,
             size_t var_val_len,
             u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to logSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to logSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val != 1 && *(long*)var_val != 0 ) {
            fprintf(stderr, "write to logSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:logSettings:syslogStatus");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.syslog));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_syslogsrvip(int action,
                  u_char * var_val,
                  u_char var_val_type,
                  size_t var_val_len,
                  u_char * statP, oid * name, size_t name_len)
{
    u_long          value;
    int             size;
    char            buff[50] = {0};
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_IPADDRESS) {
            fprintf(stderr, "write to logSettings not ASN_IPADDRESS\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len != 4 ) {
            fprintf(stderr, "write to logSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
         strcpy(req_name, "system:logSettings");
         strcat(req_name, ":");
         strcat(req_name, "syslogStatus");
         rv = get_one(req_name,buff);
         if(!rv){
                node.syslog = atoi(buff);
            if(node.syslog == 0){
                fprintf(stderr, "write to logSettings: bad value\n");
                 return SNMP_ERR_WRONGVALUE;
        }
        }
        else return NULL;
       
        if(isValidIP(var_val)) {
            fprintf(stderr, "write to logSettings: bad Value\n");
            return SNMP_ERR_WRONGVALUE;
        }

        break;

        break;

    case RESERVE2:
        size = var_val_len;
        value = *(u_long *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	sprintf(req_name,"system:logSettings:syslogSrvIp");
        sprintf(str,"%d.%d.%d.%d",var_val[0],var_val[1],var_val[2],var_val[3]);

        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	sprintf(str,"%d.%d.%d.%d",node.syslogsrvip[0],node.syslogsrvip[1],node.syslogsrvip[2],node.syslogsrvip[3]);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_syslogsrvport(int action,
                    u_char * var_val,
                    u_char var_val_type,
                    size_t var_val_len,
                    u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
    char            buff[50] = {0};
 
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to logSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to logSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if (*(long*)var_val < 1 || *(long*)var_val > 65535 ) {
            fprintf(stderr, "write to logSettings: bad value\n");
            return SNMP_ERR_WRONGVALUE;
        }

         strcpy(req_name, "system:logSettings");
         strcat(req_name, ":");
         strcat(req_name, "syslogStatus");
         rv = get_one(req_name,buff);
         if(!rv){
                node.syslog = atoi(buff);
            if(node.syslog == 0){
                fprintf(stderr, "write to logSettings: bad value\n");
                 return SNMP_ERR_WRONGVALUE;
        }
        }
        else return NULL;

        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	value = *(long *)var_val;
	sprintf(req_name,"system:logSettings:syslogSrvPort");
	sprintf(str,"%lu",value);
        rv = db_set(req_name,str);
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
	rv = db_set(req_name,(char *)&(node.syslogsrvport));
	if(rv)
        {
                return SNMP_ERR_GENERR;
        }
        break;

    case COMMIT:
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
	if( db_save() ){
                return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}


