/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "statistic.h"

w_Eth_Stat wEthStat;
wl_Stat_T wlStatT;
static char db_wlStatT [MAX_NAME_LEN] = {0};

/*
 * statistic_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             statistic_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 7 };

/*
 * variable4 statistic_variables:
 *   this variable defines function callbacks and type return information 
 *   for the statistic mib section 
 */

struct variable7 statistic_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */
#define LANRECVPACKET		1
    {LANRECVPACKET, ASN_UNSIGNED, RONLY, var_statistic, 2, {1, 1}},
#define LANTRANSPACKET		2
    {LANTRANSPACKET, ASN_UNSIGNED, RONLY, var_statistic, 2, {1, 2}},
#define LANRECVBYTES		3
    {LANRECVBYTES, ASN_UNSIGNED, RONLY, var_statistic, 2, {1, 3}},
#define LANTRANSBYTES		4
    {LANTRANSBYTES, ASN_UNSIGNED, RONLY, var_statistic, 2, {1, 4}},

#define WLANRECVUNICASTPACKET		5
    {WLANRECVUNICASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 1}},
#define WLANTRANSUNICASTPACKET		6
    {WLANTRANSUNICASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 2}},
#define WLANRECVBROADCASTPACKET		7
    {WLANRECVBROADCASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable,
     3, {2, 1, 3}},
#define WLANTRANSBROADCASTPACKET		8
    {WLANTRANSBROADCASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable,
     3, {2, 1, 4}},
#define WLANRECVMULTICASTPACKET		9
    {WLANRECVMULTICASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable,
     3, {2, 1, 5}},
#define WLANTRANSMULTICASTPACKET		10
    {WLANTRANSMULTICASTPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable,
     3, {2, 1, 6}},
#define WLANRECVPACKET		11
    {WLANRECVPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 7}},
#define WLANTRANSPACKET		12
    {WLANTRANSPACKET, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 8}},
#define WLANRECVBYTES		13
    {WLANRECVBYTES, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 9}},
#define WLANTRANSBYTES		14
    {WLANTRANSBYTES, ASN_UNSIGNED, RONLY, var_wirelessStatTable, 3,
     {2, 1, 10}},
};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the statistic module */
void
init_statistic(void)
{

    DEBUGMSGTL(("statistic", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("statistic", statistic_variables, variable7,
                 statistic_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_statistic():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_statistic(struct variable *vp,
              oid * name,
              size_t *length,
              int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;
    char ret_buf[255],req_name[255];
    int rv;
	
    if (header_generic(vp, name, length, exact, var_len, write_method)
        == MATCH_FAILED)
        return NULL;

    strcpy(req_name,"system:monitor:stats:lan:");

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case LANRECVPACKET:
	*var_len = sizeof(int);	
	strcat(req_name,"lanRecvPacket");
	rv = get_one(req_name,ret_buf);
	if(rv)
		wEthStat.lan_Recv_Pkt = 0;
	else
		wEthStat.lan_Recv_Pkt = atoi(ret_buf);	
        return (u_char *) & wEthStat.lan_Recv_Pkt;
    case LANTRANSPACKET:
	*var_len = sizeof(int);
        strcat(req_name,"lanTransPacket");
        rv = get_one(req_name,ret_buf);
        if(rv)
                wEthStat.lan_Trans_Pkt = 0;
        else
                wEthStat.lan_Trans_Pkt = atoi(ret_buf);
        return (u_char *) & wEthStat.lan_Trans_Pkt;
    case LANRECVBYTES:
	*var_len = sizeof(int);
        strcat(req_name,"lanRecvBytes");
        rv = get_one(req_name,ret_buf);
        if(rv)
                wEthStat.lan_Recv_Bytes = 0;
        else
                wEthStat.lan_Recv_Bytes = atoi(ret_buf);
        return (u_char *) & wEthStat.lan_Recv_Bytes;
    case LANTRANSBYTES:
	*var_len = sizeof(int);
        strcat(req_name,"lanTransBytes");
        rv = get_one(req_name,ret_buf);
        if(rv)
                wEthStat.lan_Trans_Bytes = 0;
        else
                wEthStat.lan_Trans_Bytes = atoi(ret_buf);
        return (u_char *) & wEthStat.lan_Trans_Bytes;
    default:
        ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_wirelessStatTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_statistic above.
 */
unsigned char  *
var_wirelessStatTable(struct variable *vp,
                      oid * name,
                      size_t *length,
                      int exact,
                      size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	oid newoid [MAX_OID_LEN];
        int rtest,i,index1 = -1,index2 = 0,rv = 0,len = 0;
        char *db_name = db_wlStatT;
        char ret_buf[100] = {0};
        char idx_name1[100] = {0};
	

        #if 0
        snmp_log(LOG_ERR,"\nvapWepT--I/P OID vpName : ");
        FOR(I=0;i < vp->namelen; i++)
                snmp_log(LOG_ERR,".%d",(int)vp->name[i]);
        snmp_log(LOG_ERR,"\nvapWepT--I/P OID name   : ");
        for(i=0;i < *length; i++)
                snmp_log(LOG_ERR,".%d",(int)name[i]);
        #endif
	/*MK Define different cases*/
        /*check if name lesser or greater than vp->name*/
        for (i = 0, rtest = 0;
         i < (int) vp->namelen && i < (int) (*length) && !rtest; i++)
        {
                if (name[i] != vp->name[i])
                {
                        if (name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

         /*Case1:name is greater than vp->name return NULL*/
        if( rtest > 0 || ( (exact == 1) && ( ((int) *length != (int) (vp->namelen + 1)) || rtest) ) )
        {
                if (var_len)
                    *var_len = 0;
                return NULL;
        }

        memset(newoid, 0, sizeof(newoid));
        memcpy((u_char *)newoid, (u_char *)vp->name, (int) (vp->namelen) * sizeof(oid));
        strcpy(db_name,"system:monitor:stats");
        len = vp->namelen;
	 /*Case2:vp->name greater than name or vp->namelen is greater than namelenght*/
        /*Get First Row First Column*/
        if ( rtest == -1 || ((int) *length) <= ((int) (vp->namelen )) )
        {
		index1 = -1;
                rv = wlan_index(&index1);
		snmp_log(LOG_ERR,"\n Get Operation  %d \n",index1);
                if(rv == -1)
                {
                        snmp_log(LOG_ERR,"\n First Row :Err reading the WlanIndex \n");
                        return NULL;
                }

		/*
                rv = first_row(db_name,&index1,NULL,idx_name1,NULL);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nErr reading the data base\n");
                        return NULL;
                }*/
        }

        /*Case3:name is greater than vp->name*/
        /*Get next operation*/
        /*exact case checked earlier*/


        else if (((int) *length) >= (int) (vp->namelen + 1))
        {
                snmp_log(LOG_ERR,"\n GetNext Operation  %d \n",index1);
		rv = eval_wlanIndex(index1);
		snmp_log(LOG_ERR,"\n After GetNext  Operation  %d \n",index1);
	        if( rv == -1 ) {
        	        return NULL;
		}
		if(!exact) {
                         snmp_log(LOG_ERR,"\n if !exact  %d \n",index1);
			rv = wlan_index(&index1);
                        if(rv == -1) {
                                snmp_log(LOG_ERR,"\n get_wlanIndex_next :ERR\n");
                                return NULL;
                        }
		}

		/*
                index1 = (int) name[len];
		rv = db_get_row(db_name,exact,&index1,NULL,idx_name1,NULL) ;
                if( rv )
                        return NULL;
		*/
        }
	(*length) = vp->namelen + 1;
        newoid[len] = (oid) index1;
        memmove(name, newoid, (*length) * sizeof(oid));

        *var_len = 4;   /*Default*/
        *write_method = NULL;
	
	rv = get_ifName(index1,idx_name1);
        if(rv == -1) {
                snmp_log(LOG_ERR,"\nget_ifName : unkown ifIndex \n");
                return NULL;
        }
        strcpy(db_name,"system:monitor:stats");
        strcat(db_name,":");
        strcat(db_name,idx_name1);
        strcat(db_name,":");

        #if 0
        snmp_log(LOG_ERR,"\nO/P OID : ");
        for(i=0;i < *length; i++)
                snmp_log(LOG_ERR,".%d",(int)name[i]);
        #endif
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case WLANRECVUNICASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanRecvUnicastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Recv_Ucast_Pkt = 0;
        else
                wlStatT.wl_Recv_Ucast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Recv_Ucast_Pkt;
    case WLANTRANSUNICASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanTransUnicastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Trans_Ucast_Pkt = 0;
        else
                wlStatT.wl_Trans_Ucast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Trans_Ucast_Pkt;
    case WLANRECVBROADCASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanRecvBroadcastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Recv_Bcast_Pkt = 0;
        else
                wlStatT.wl_Recv_Bcast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Recv_Bcast_Pkt;
    case WLANTRANSBROADCASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanTransBroadcastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Trans_Bcast_Pkt = 0;
        else
                wlStatT.wl_Trans_Bcast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Trans_Bcast_Pkt;
    case WLANRECVMULTICASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanRecvMulticastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Recv_Mcast_Pkt = 0;
        else
                wlStatT.wl_Recv_Mcast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Recv_Mcast_Pkt;
    case WLANTRANSMULTICASTPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanTransMulticastPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Trans_Mcast_Pkt = 0;
        else
                wlStatT.wl_Trans_Mcast_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Trans_Mcast_Pkt;
    case WLANRECVPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanRecvPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Recv_Pkt = 0;
        else
                wlStatT.wl_Recv_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Recv_Pkt;
    case WLANTRANSPACKET:
	*var_len = sizeof(int);
        strcat(db_name,"wlanTransPacket");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Trans_Pkt = 0;
        else
                wlStatT.wl_Trans_Pkt = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Trans_Pkt;
    case WLANRECVBYTES:
	*var_len = sizeof(int);
        strcat(db_name,"wlanRecvBytes");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Recv_Bytes = 0;
        else
                wlStatT.wl_Recv_Bytes = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Recv_Bytes;
    case WLANTRANSBYTES:
	*var_len = sizeof(int);
        strcat(db_name,"wlanTransBytes");
        rv = get_one(db_name,ret_buf);
        if(rv)
                wlStatT.wl_Trans_Bytes = 0;
        else
                wlStatT.wl_Trans_Bytes = atoi(ret_buf);
        return (u_char *) & wlStatT.wl_Trans_Bytes;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
