/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "wmmSettings.h"
#include "wmmSet.h"

#define DEBUG_MK(fmt,arg...) snmp_log(LOG_ERR,fmt,##arg)

#define MAX_DBNAME_LEN 256
wmm_set1 wmmset1;
wmm_set2 wmmset2;
static char wmm_name1 [MAX_DBNAME_LEN];
static char wmm_name2 [MAX_DBNAME_LEN];

/*
 * wmmSettings_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             wmmSettings_variables_oid[] =
    { 1, 3, 6, 1, 4, 1, 4526, 100, 7, 4, 5 };

/*
 * variable4 wmmSettings_variables:
 *   this variable defines function callbacks and type return information 
 *   for the wmmSettings mib section 
 */

struct variable7 wmmSettings_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define WMMAPEDCAQINDEX		1
    {WMMAPEDCAQINDEX, ASN_INTEGER, RONLY, var_wmmApEdcaSettingTable, 3,
     {1, 1, 1}},
#define WMMAPEDCAQNAME		2
    {WMMAPEDCAQNAME, ASN_OCTET_STR, RONLY, var_wmmApEdcaSettingTable, 3,
     {1, 1, 2}},
#define WMMAPEDCAAIFS		3
    {WMMAPEDCAAIFS, ASN_INTEGER, RWRITE, var_wmmApEdcaSettingTable, 3,
     {1, 1, 3}},
#define WMMAPEDCACWMIN		4
    {WMMAPEDCACWMIN, ASN_INTEGER, RWRITE, var_wmmApEdcaSettingTable, 3,
     {1, 1, 4}},
#define WMMAPEDCACWMAX		5
    {WMMAPEDCACWMAX, ASN_INTEGER, RWRITE, var_wmmApEdcaSettingTable, 3,
     {1, 1, 5}},
#define WMMAPEDCAMAXBURST		6
    {WMMAPEDCAMAXBURST, ASN_INTEGER, RWRITE, var_wmmApEdcaSettingTable,
     3, {1, 1, 6}},
#define WMMSTAEDCAQINDEX		7
    {WMMSTAEDCAQINDEX, ASN_INTEGER, RONLY, var_wmmStaEdcaSettingTable, 3,
     {2, 1, 1}},
#define WMMSTAEDCAQNAME		8
    {WMMSTAEDCAQNAME, ASN_OCTET_STR, RONLY, var_wmmStaEdcaSettingTable, 3,
     {2, 1, 2}},
#define WMMSTAEDCAAIFS		9
    {WMMSTAEDCAAIFS, ASN_INTEGER, RWRITE, var_wmmStaEdcaSettingTable, 3,
     {2, 1, 3}},
#define WMMSTAEDCACWMIN		10
    {WMMSTAEDCACWMIN, ASN_INTEGER, RWRITE, var_wmmStaEdcaSettingTable, 3,
     {2, 1, 4}},
#define WMMSTAEDCACWMAX		11
    {WMMSTAEDCACWMAX, ASN_INTEGER, RWRITE, var_wmmStaEdcaSettingTable, 3,
     {2, 1, 5}},
#define WMMSTAEDCATXOPLIMIT		12
    {WMMSTAEDCATXOPLIMIT, ASN_INTEGER, RWRITE,
     var_wmmStaEdcaSettingTable, 3, {2, 1, 6}},
};

/*
 * (L = length of the oidsuffix) 
 */


/** Initializes the wmmSettings module */
void
init_wmmSettings(void)
{

    DEBUGMSGTL(("wmmSettings", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("wmmSettings", wmmSettings_variables, variable7,
                 wmmSettings_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
}

/*
 * var_wmmSettings():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char  *
var_wmmSettings(struct variable *vp,
                oid * name,
                size_t *length,
                int exact, size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    default:
        ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_wmmApEdcaSettingTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wmmSettings above.
 */
unsigned char  *
var_wmmApEdcaSettingTable(struct variable *vp,
                          oid * name,
                          size_t *length,
                          int exact,
                          size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	oid newoid [MAX_OID_LEN] = {0};
	int rtest,i,index1 = 0,index2 = 0,rv = 0,len = 0;
	char *db_name = wmm_name1;
	char newname[MAX_DBNAME_LEN] = {0};
	char idx_name1[100] = {0};
	char idx_name2[100] = {0};
	char val[100] = {0};
    /*
     * This assumes that the table is a 'simple' table.
     *  See the implementation documentation for the meaning of this.
     *  You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *  you will need to provide the replacement code yourself.
     *  Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */

	#if 0
	printf("\n\nwdsSettingTable :Input OID : ");
        for(i=0;i < *length; i++)
                printf(".%d",(int)name[i]);
        printf("\nwdsSettingTable :vp->name  : ");
        for(i=0;i < vp->namelen; i++)
                printf(".%d",(int)vp->name[i]);
        printf("\n\n "); 
	#endif

	/*MK Define different cases*/
        /*check if name lesser or greater than vp->name*/
        for (i = 0, rtest = 0;
         i < (int) vp->namelen && i < (int) (*length) && !rtest; i++)
        {
                if (name[i] != vp->name[i])
                {
                        if (name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
	}

	/*Case1:name is greater than vp->name return NULL*/
        if( rtest > 0 || ((exact == 1) && (((int) *length != (int)(vp->namelen + 2)) || rtest)))
        {
                if (var_len)
                    *var_len = 0;
                return NULL;
        }

        memset(newoid, 0, sizeof(newoid));
        memcpy((u_char *)newoid, (u_char *)vp->name, (int) (vp->namelen) * sizeof(oid));
	len = vp->namelen;
	strcpy(db_name,"system:wmmSettings:wmmApEdcaSettingTable");

	 /*Case2:vp->name greater than name or vp->namelen is greater than namelenght*/
        /*Get First Row First Column*/
        if ( rtest == -1 || ((int) *length) <= ((int) (vp->namelen + 1)) )
        {
                rv = first_row(db_name,&index1,&index2,idx_name1,idx_name2);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nfirst_row : Err reading the data base\n");
                        return NULL;
                }
        }
	/*Case3:name is greater than vp->name*/
        /*Get next operation*/
        /*exact case checked earlier*/
        else if (((int) *length) >= (int) (vp->namelen + 2))
        {
                index1 = (int) name[len];
                index2 = (int) name[len + 1];

		rv = db_get_row(db_name,exact,&index1,&index2,idx_name1,idx_name2) ;
		if(rv)
			return NULL;
	}

        (*length) = vp->namelen + 2;
        newoid[len] = (oid) index1;
        newoid[len + 1] = (oid) index2;
        memmove(name, newoid, (*length) * sizeof(oid));

        *var_len = 4;   /*Default*/
        *write_method = NULL;

	wmmset1.edcq_idx = index2;
        strcpy(db_name,"system:wmmSettings:wmmApEdcaSettingTable");
        strcat(db_name,":");
	strcat(db_name,idx_name1);
	strcat(db_name,":");
	strcat(db_name,idx_name2);
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case WMMAPEDCAQINDEX:
	return (u_char *) &wmmset1.edcq_idx;
    case WMMAPEDCAQNAME:
	if(get_Qname(wmmset1.edcq_idx,wmmset1.edcq_name))
		return NULL;	
	*var_len = strlen(wmmset1.edcq_name);
        return (u_char *) wmmset1.edcq_name;
    case WMMAPEDCAAIFS:
        *write_method = write_wmmApEdcaAifs;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmApEdcaAifs");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset1.edcq_if = 0;
    		return NULL;
	}
	else
		wmmset1.edcq_if = atoi(val);
        return (u_char *) & wmmset1.edcq_if;
    case WMMAPEDCACWMIN:
        *write_method = write_wmmApEdcaCwMin;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmApEdcaCwMin");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset1.edcq_min = 0;
    		return NULL;
	}
	else
		wmmset1.edcq_min = atoi(val);
        return (u_char *) & wmmset1.edcq_min;
    case WMMAPEDCACWMAX:
        *write_method = write_wmmApEdcaCwMax;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmApEdcaCwMax");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset1.edcq_max = 0;
    		return NULL;
	}
	else
		wmmset1.edcq_max = atoi(val);
        return (u_char *) & wmmset1.edcq_max;
    case WMMAPEDCAMAXBURST:
        *write_method = write_wmmApEdcaMaxBurst;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmApEdcaMaxBurst");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset1.edcq_maxburst = 0;
    		return NULL;
	}
	else
                wmmset1.edcq_maxburst = atoi(val);
        return (u_char *) & wmmset1.edcq_maxburst;
    default:
        ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_wmmStaEdcaSettingTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wmmSettings above.
 */
unsigned char  *
var_wmmStaEdcaSettingTable(struct variable *vp,
                           oid * name,
                           size_t *length,
                           int exact,
                           size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	oid newoid [MAX_OID_LEN] = {0};
	int rtest,i,index1 = 0,index2 = 0,rv = 0,len = 0;
	char *db_name = wmm_name2;
	char newname[MAX_DBNAME_LEN] = {0};
	char idx_name1[100] = {0};
	char idx_name2[100] = {0};
	char val[100] = {0};

	#if 0
	printf("\n\nwdsSettingTable :Input OID : ");
        for(i=0;i < *length; i++)
                printf(".%d",(int)name[i]);
        printf("\nwdsSettingTable :vp->name  : ");
        for(i=0;i < vp->namelen; i++)
                printf(".%d",(int)vp->name[i]);
        printf("\n\n ");
	#endif

    /*
     * This assumes that the table is a 'simple' table.
     *  See the implementation documentation for the meaning of this.
     *  You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *  you will need to provide the replacement code yourself.
     *  Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
	/*MK Define different cases*/
        /*check if name lesser or greater than vp->name*/
        for (i = 0, rtest = 0;
         i < (int) vp->namelen && i < (int) (*length) && !rtest; i++)
        {
                if (name[i] != vp->name[i])
                {
                        if (name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
	}

	/*Case1:name is greater than vp->name return NULL*/
        if( rtest > 0 || ( (exact == 1) && ( ((int) *length != (int) (vp->namelen + 2)) || rtest) ) )
        {
                if (var_len)
                    *var_len = 0;
                return NULL;
        }

        memset(newoid, 0, sizeof(newoid));
        memcpy((u_char *)newoid, (u_char *)vp->name, (int) (vp->namelen) * sizeof(oid));
	len = vp->namelen;
	strcpy(db_name,"system:wmmSettings:wmmStaEdcaSettingTable");

	 /*Case2:vp->name greater than name or vp->namelen is greater than namelenght*/
        /*Get First Row First Column*/
        if ( rtest == -1 || ((int) *length) <= ((int) (vp->namelen + 1)) )
        {
                rv = first_row(db_name,&index1,&index2,idx_name1,idx_name2);
                if(rv)
                {
                        snmp_log(LOG_ERR,"\nFirst row : Err reading the data base\n");
                        return NULL;
                }
        }

	/*Case3:name is greater than vp->name*/
        /*Get next operation*/
        /*exact case checked earlier*/
        else if (((int) *length) >= (int) (vp->namelen + 2))
        {
                index1 = (int) name[len];
                index2 = (int) name[len + 1];
		
		rv = db_get_row(db_name,exact,&index1,&index2,idx_name1,idx_name2) ;
                if( rv )
                        return NULL;	
        }

        (*length) = vp->namelen + 2;
        newoid[len] = (oid) index1;
        newoid[len + 1] = (oid) index2;
        memmove(name, newoid, (*length) * sizeof(oid));

        *var_len = 4;   /*Default*/
        *write_method = NULL;

	wmmset2.staq_idx = index2;
        strcpy(db_name,"system:wmmSettings:wmmStaEdcaSettingTable");
        strcat(db_name,":");
	strcat(db_name,idx_name1);
	strcat(db_name,":");
	strcat(db_name,idx_name2);

	#if 0	
	printf("\n\nwdsSettingTable :Op OID : ");
        for(i=0;i < *length; i++)
                printf(".%d",(int)name[i]);
        printf("\n\n ");
	#endif

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case WMMSTAEDCAQINDEX:
	return (u_char *)&(wmmset2.staq_idx);
    case WMMSTAEDCAQNAME:
	if(get_Qname(wmmset2.staq_idx,wmmset2.staq_name))
		return NULL;	
	*var_len = strlen(wmmset2.staq_name);
        return (u_char *) wmmset2.staq_name;
    case WMMSTAEDCAAIFS:
        *write_method = write_wmmStaEdcaAifs;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmStaEdcaAifs");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset2.staq_if = 0;
    		return NULL;
	}
	else
		wmmset2.staq_if = atoi(val);
        return (u_char *) & wmmset2.staq_if;
    case WMMSTAEDCACWMIN:
        *write_method = write_wmmStaEdcaCwMin;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmStaEdcaCwMin");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset2.staq_min = 0;
    		return NULL;
	}
	else
		wmmset2.staq_min = atoi(val);
        return (u_char *) & wmmset2.staq_min;
    case WMMSTAEDCACWMAX:
        *write_method = write_wmmStaEdcaCwMax;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmStaEdcaCwMax");
        rv = get_one(newname,val);
        if(rv)
	{
		wmmset2.staq_max = 0;
    		return NULL;
	}
	else
		wmmset2.staq_max = atoi(val);
        return (u_char *) & wmmset2.staq_max;
    case WMMSTAEDCATXOPLIMIT:
        *write_method = write_wmmStaEdcaTxopLimit;
	strcpy(newname,db_name);
        strcat(newname,":");
        strcat(newname,"wmmStaEdcaTxopLimit");
        snmp_log(LOG_ERR,"\n newname WMMSTAEDCATXOPLIMIT: = \n%s",newname);
        rv = get_one(newname,val);
        if(rv)
	{
                wmmset2.staq_oplmt = 0;
    		return NULL;
	}
        else
		wmmset2.staq_oplmt = atoi(val);
        return (u_char *) & wmmset2.staq_oplmt;
    default:
        ERROR_MSG("");
    }
    return NULL;
}


int
write_wmmApEdcaAifs(int action,
                    u_char * var_val,
                    u_char var_val_type,
                    size_t var_val_len,
                    u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	if(*(long*)var_val < 0 || *(long*)var_val > 8) {
		fprintf(stderr,"Write to wmmApEdcaAifs : bad value\n");
		return SNMP_ERR_BADVALUE;
	}
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	
	 {
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name1);
                strcat(newname,":");
                strcat(newname,"wmmApEdcaAifs");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
        }

	
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}

        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmApEdcaCwMin(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
    int		    i,flag=0;
	

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	for( i = 0 ; i < 11 ; i ++)
        {
        	if((*(long*)var_val) == (pow(2,i) - 1)) 
			flag = 1;
        }
        if(!flag) {
                fprintf(stderr,"Write to wmmApEdcaCwMin :: bad value\n");
                return SNMP_ERR_BADVALUE;
        }

	/*if(*(long*)var_val < 1 || *(long*)var_val > 1024 ) {
		fprintf(stderr,"Write to wmmApEdcaCwmin : bad value\n");
		return SNMP_ERR_BADVALUE;
	}*/
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name1);
                strcat(newname,":");
                strcat(newname,"wmmApEdcaCwMin");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmApEdcaCwMax(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
	int i = 1,flag = 0 ;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	for( i = 0 ; i < 11 ; i ++)
	{
		if((*(long*)var_val) == (pow(2,i) - 1)) 
			flag = 1;
	}
	if(!flag) {		
		fprintf(stderr,"Write to wmmApEdcaAifs :: bad value\n");
		return SNMP_ERR_BADVALUE;
	}
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name1);
                strcat(newname,":");
                strcat(newname,"wmmApEdcaCwMax");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmApEdcaMaxBurst(int action,
                        u_char * var_val,
                        u_char var_val_type,
                        size_t var_val_len,
                        u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        if(*(long*)var_val < 0 || *(long*)var_val > 8192) {
            fprintf(stderr,"Write to write_wmmApEdcaMaxBurst : bad value\n");
            return SNMP_ERR_BADVALUE;
        }
        break;

    case RESERVE2:
       // size = var_val_len;
       // value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *) var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name1);
                snmp_log(LOG_ERR,"\n newname APEDCA wmm_name1 = \n%s",newname);
                strcat(newname,":");
                strcat(newname,"wmmApEdcaMaxBurst");
                snmp_log(LOG_ERR,"\n newname APEDCA: = \n%s",newname);
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmStaEdcaAifs(int action,
                     u_char * var_val,
                     u_char var_val_type,
                     size_t var_val_len,
                     u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }		
	if(*(long*)var_val < 0 || *(long*)var_val > 8 ) {
		fprintf(stderr,"Write to wmmStaEdcaAifs : bad value\n");
		return SNMP_ERR_BADVALUE;
	}
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name2);
                strcat(newname,":");
                strcat(newname,"wmmStaEdcaAifs");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmStaEdcaCwMin(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
    int             i,flag=0;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	for( i = 0 ; i < 11 ; i ++)
        {
                if((*(long*)var_val) == (pow(2,i) - 1))
                        flag = 1;
        }
        if(!flag) {
                fprintf(stderr,"Write to wmmStaEdcaCwMin :: bad value\n");
                return SNMP_ERR_BADVALUE;
        }

	/*if(*(long*)var_val < 1 || *(long*)var_val > 1024 ) {
		fprintf(stderr,"Write to wmmStaEdcaCwMin : bad value\n");
		return SNMP_ERR_BADVALUE;
	}*/
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name2);
                strcat(newname,":");
                strcat(newname,"wmmStaEdcaCwMin");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmStaEdcaCwMax(int action,
                      u_char * var_val,
                      u_char var_val_type,
                      size_t var_val_len,
                      u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;
	int i = 1,flag = 0 ;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
	for( i = 0 ; i < 11 ; i ++)
	{
		if((*(long*)var_val) == (pow(2,i) - 1))
			flag = 1;
	}
	if(!flag) {		
		fprintf(stderr,"Write to wmmStaEdcaCwMax :: bad value\n");
		return SNMP_ERR_BADVALUE;
	}
        break;

    case RESERVE2:

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *)var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name2);
                strcat(newname,":");
                strcat(newname,"wmmStaEdcaCwMax");
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_wmmStaEdcaTxopLimit(int action,
                          u_char * var_val,
                          u_char var_val_type,
                          size_t var_val_len,
                          u_char * statP, oid * name, size_t name_len)
{
    long            value;
    int             size;

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to wmmSettings not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to wmmSettings: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }   
        if(*(long*)var_val < 0 || *(long*)var_val > 8192) {
            fprintf(stderr,"Write to wmmStaEdcaTxopLimit : bad value\n");
            return SNMP_ERR_BADVALUE;
        }       
         snmp_log(LOG_ERR,"\n INSIDE RESERVE 1");
        break;

    case RESERVE2:
       // size = var_val_len;
       // value = *(char *) var_val;

        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
	{
                char newname[MAX_DBNAME_LEN] = {0};
                char val[100] = {0};
                int rv = 0;
                value = *(long *) var_val;
                /*Check for validation TBD*/
                strcpy(newname,wmm_name2);
                strcat(newname,":");
                strcat(newname,"wmmStaEdcaTxopLimit");
                snmp_log(LOG_ERR,"\n newname write_WMMSTAEDCATXOPLIMIT: = \n%s",newname);
                sprintf(val,"%lu",value);
                rv = set_one(newname,val);
                if(rv)
                {
                        DEBUG_MK("Set to db failed\n");
                        return SNMP_ERR_GENERR;
                }
	}
        /*
         * The variable has been stored in 'value' for you to use,
         * and you have just been asked to do something with it.
         * Note that anything done here must be reversable in the UNDO case
         */
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
		{
			int rv = 0;
			rv = db_save();
			if(rv)
				return SNMP_ERR_COMMITFAILED;
		}
        /*
         * Things are working well, so it's now safe to make the change
         * permanently.  Make sure that anything done here can't fail!
         */
        break;
    }
    return SNMP_ERR_NOERROR;
}
