/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11MultiDomainCapabilityTable.h"
#include "ieee802dot11_info.h"
#include "MultiDoamianCapability.h"
/*
 * dot11MultiDomainCapabilityTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11MultiDomainCapabilityTable_variables_oid[] =
    { 1, 2, 840, 10036, 1, 7 };

/*
 * variable4 dot11MultiDomainCapabilityTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11MultiDomainCapabilityTable mib section 
 */

struct variable7 dot11MultiDomainCapabilityTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11MULTIDOMAINCAPABILITYINDEX		1
    {DOT11MULTIDOMAINCAPABILITYINDEX, ASN_INTEGER, RONLY,
     var_dot11MultiDomainCapabilityTable, 2, { 1, 1}},
#define DOT11FIRSTCHANNELNUMBER		2
    {DOT11FIRSTCHANNELNUMBER, ASN_INTEGER, RONLY,
     var_dot11MultiDomainCapabilityTable, 2, { 1, 2}},
#define DOT11NUMBEROFCHANNELS		3
    {DOT11NUMBEROFCHANNELS, ASN_INTEGER, RONLY,
     var_dot11MultiDomainCapabilityTable, 2, { 1, 3}},
#define DOT11MAXIMUMTRANSMITPOWERLEVEL		4
    {DOT11MAXIMUMTRANSMITPOWERLEVEL, ASN_INTEGER, RONLY,
     var_dot11MultiDomainCapabilityTable, 2, { 1, 4}},
};

/*
 * (L = length of the oidsuffix) 
 */
list_T mdc_list;
void init_multidomain()
{
	LIST_INIT (&mdc_list);
}

/** Initializes the dot11MultiDomainCapabilityTable module */
void
init_dot11MultiDomainCapabilityTable(void)
{

    DEBUGMSGTL(("dot11MultiDomainCapabilityTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11MultiDomainCapabilityTable",
                 dot11MultiDomainCapabilityTable_variables, variable7,
                 dot11MultiDomainCapabilityTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	init_multidomain();
}

/*
 * var_dot11MultiDomainCapabilityTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11MultiDomainCapabilityTable above.
 */
unsigned char  *
var_dot11MultiDomainCapabilityTable(struct variable *vp,
                                    oid * name,
                                    size_t *length,
                                    int exact,
                                    size_t *var_len,
                                    WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;

	mdcTbl_data *mdc = NULL;
	int i,len=0,rtest;
	oid newname[MAX_OID_LEN];

	for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

	/*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 1)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

	/*
	*Load Authen-Algorithm List Tables
	*/
	if(load_Table(load_mdctbl,&mdc_list))
	{
		snmp_log(LOG_ERR,"Sctble load failed\n");
		return NULL;
	}

	if(LIST_EMPTY (&mdc_list) )
	{
		snmp_log(LOG_ERR,"\nAuthentication Algo Tabe Empty\n");
		return NULL;
	}
	
	
	memset (newname, 0, sizeof(newname));
	memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
	
	 /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen || rtest == -1 || 
		(int) *length == (int) (vp->namelen + 1))
        {
                len = vp->namelen;
                mdc = (mdcTbl_data *) mdc_list.l_head->data;
                newname[len] = mdc->ifindex;
		newname[len + 1] = mdc->index;
                *length = vp->namelen + 2;
        }

	/*Case3:When namelength is greater than or equal to vpnamelen + 2*/
        else if( (int)*length >= (int) (vp->namelen + 2) )
        {
                len = vp->namelen;
                mdc = mdcList_get(&mdc_list,(int)name[len],(int)name[len+1],exact);
                if(!mdc)
                {
                        return NULL;
                }
                newname[len] = mdc->ifindex;
                newname[len + 1] = mdc->index;
                *length = vp->namelen + 2;
	}

        memcpy(name,newname,(*length) * sizeof(oid));
        *var_len = sizeof(int);      /*Default*/

    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11MULTIDOMAINCAPABILITYINDEX:
        return (u_char *) & mdc->index;
    case DOT11FIRSTCHANNELNUMBER:
        return (u_char *) & mdc->first_ch;
    case DOT11NUMBEROFCHANNELS:
        return (u_char *) & mdc->num_ch;
    case DOT11MAXIMUMTRANSMITPOWERLEVEL:
        return (u_char *) & mdc->max_pwr;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
