/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.6 2006/04/18 17:36:16 hardaker Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "dot11PhyOperationTable.h"
#include "ieee802dot11_info.h"
#include "PhyOperation.h"
/*
 * dot11PhyOperationTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             dot11PhyOperationTable_variables_oid[] =
    { 1, 2, 840, 10036, 4, 1 };

/*
 * variable4 dot11PhyOperationTable_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dot11PhyOperationTable mib section 
 */

struct variable7 dot11PhyOperationTable_variables[] = {
    /*
     * magic number        , variable type , ro/rw , callback fn  , L, oidsuffix 
     */

#define DOT11PHYTYPE		1
    {DOT11PHYTYPE, ASN_INTEGER, RONLY, var_dot11PhyOperationTable, 2,
     { 1, 1}},
#define DOT11CURRENTREGDOMAIN		2
    {DOT11CURRENTREGDOMAIN, ASN_INTEGER, RONLY, var_dot11PhyOperationTable,
     2, { 1, 2}},
#define DOT11TEMPTYPE		3
    {DOT11TEMPTYPE, ASN_INTEGER, RONLY, var_dot11PhyOperationTable, 2,
     { 1, 3}},
};

/*
 * (L = length of the oidsuffix) 
 */
list_T po_list;
void init_phyoperation()
{
	LIST_INIT (&po_list);
}
/** Initializes the dot11PhyOperationTable module */
void
init_dot11PhyOperationTable(void)
{

    DEBUGMSGTL(("dot11PhyOperationTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    REGISTER_MIB("dot11PhyOperationTable",
                 dot11PhyOperationTable_variables, variable7,
                 dot11PhyOperationTable_variables_oid);

    /*
     * place any other initialization junk you need here 
     */
	init_phyoperation();
}


/*
 * var_dot11PhyOperationTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dot11PhyOperationTable above.
 */
unsigned char  *
var_dot11PhyOperationTable(struct variable *vp,
                           oid * name,
                           size_t *length,
                           int exact,
                           size_t *var_len, WriteMethod ** write_method)
{
    /*
     * variables we may use later 
     */
    static long     long_ret;
    static u_long   ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid      objid[MAX_OID_LEN];
    static struct counter64 c64;


	poTbl_data *npo;
	int i,len=0,rtest;
	oid newname[MAX_OID_LEN];

	for(i = 0, rtest = 0;
                i < (int) vp -> namelen && i < (int) (*length) && !rtest; i++) {
                if(name[i] != vp -> name[i]) {
                        if(name[i] < vp->name[i])
                                rtest = -1;
                        else
                                rtest = 1;
                }
        }

	/*Case1: name is greater than vp->name return NULL
                or name=vpname and is exact case*/
        if(rtest > 0 || ((exact == 1) && (((int) *length != (int) (vp->namelen + 1)
                 || rtest))))
        {
                if (var_len)
                        *var_len = 0;
                snmp_log(LOG_ERR,"name > vpname\n");
                return NULL;
        }

	/*
	*Load Phy Operation List Tables
	*/
	if(load_Table(load_phyoprtbl,&po_list))
	{
		snmp_log(LOG_ERR,"Sctble load failed\n");
		return NULL;
	}

	if(LIST_EMPTY (&po_list) )
	{
		snmp_log(LOG_ERR,"\nAuthentication Algo Tabe Empty\n");
		return NULL;
	}
	
	memset (newname, 0, sizeof(newname));
	memcpy( (u_char *)newname, (u_char *)vp->name, (int)(vp->namelen) * sizeof(oid));
	
	 /*Case2: vp->name greater than name or vp->namelen is greater than namelenth*/
        /*Return First Row of the Table*/
        if( (int)*length <= (int) vp->namelen || rtest == -1 )
        {
                len = vp->namelen;
                npo = (poTbl_data *) po_list.l_head->data;
                newname[len] = npo->ifindex;
                *length = vp->namelen + 1;
	}

	/*Case3:When namelength is greater than or equal to vpnamelen+1*/
        else if( (int)*length >= (int) (vp->namelen+1) )
        {
                len = vp->namelen;
                npo = PoList_get(&po_list,(int)name[len],exact);
                if(!npo)
                {
                        return NULL;
                }
                newname[len] = npo->ifindex;
                *length = vp->namelen + 1;
        }

        memcpy(name,newname,(*length) * sizeof(oid));
        *var_len = sizeof(int);      /*Default*/
	*write_method = NULL;
    /*
     * this is where we do the value assignments for the mib results.
     */
    switch (vp->magic) {
    case DOT11PHYTYPE:
        return (u_char *) & npo->phy_type;
    case DOT11CURRENTREGDOMAIN:
        return (u_char *) & npo->curr_domain;
    case DOT11TEMPTYPE:
        return (u_char *) & npo->temp_type;
    default:
        ERROR_MSG("");
    }
    return NULL;
}
