/*Linked list Defenitions*/
typedef struct list_node {
	char *data;
	struct list_node *next;
}list_node;

typedef struct list_T {
	struct list_node *l_head;
}list_T;

#define LIST_INIT(l)	(l)->l_head = NULL

#define	LIST_EMPTY(l)	((l)->l_head == NULL)

#define LIST_FIRST(l)	((l)->l_head)

#define SNMP_STR_LEN			128
#define MACADDR_LEN			6 
#define OPER_RATE_SET_LEN		126


#if 0
/*dot11OperationTable data Structures*/
typedef struct opTbl_data {

        int ifIndex;
        char  MACAddress      [ MACADDR_LEN + 1 ];
        int RTSThreshold;
        int shortRetryLimit;
        int longRetryLimit;
        int fragmentationThreshold;
        int maxTransmitMSDULifetime;
        int maxReceiveLifetime;
        char  manufacturerID  [ SNMP_STR_LEN + 1 ];
        char  productID       [ SNMP_STR_LEN + 1 ];

        unsigned int HTOperatingMode;
        unsigned int RIFSMode;
        unsigned int PSMPControlledAccess;
        int ServiceIntervalGranularity;
        unsigned int DualCTSProtection;
        unsigned int SigTXOPFullProtectionEnabled;
        unsigned int NonGFEntitiesPresent;
        unsigned int PCOActivated;
        int PCO40MaxDuration;
        int PCO20MaxDuration;
        int PCO40MinDuration;
        int PCO20MinDuration;
}opTbl_data;

opTbl_data *opTbl_node;
list_T opList;

void loadopList(list_T *opList,int skfd,char * ifName);
opTbl_data* opList_get(list_T *opList,int index,int exact);	


/*dot11CountersTable data Structures*/
typedef struct cntTbl_data {
	
	int ifIndex;
	int TransFragCount;
	int McastTransFragCount;
	int FailedCount;
	int RetryCount;
	int MultipleRetryCount;
	int FrameDuplicateCount;
	int RTSSuccessCount;
	int RTSFailureCount;
	int ACKFailureCount;
	int RcvdFragmentCount;
	int McastRcvdFrameCount;
	int FCSErrorCount;
	int TransFrameCount;
	int WEPUndecryptableCount;
	int TransAMSDUCount;
	int FailedAMSDUCount;
	int RetryAMSDUCount;
	int MRetryAMSDUCount;
	long TransOctInAMSDUCount;
	int AMSDUAckFailureCount;
	int RcvdAMSDUCount;
	long RcvdOctetsInAMSDUCount;
	int TransAMPDUCount;
	int TransMPDUsInAMPDUCount;
	long TransOctetsInAMPDUCount;
	int AMPDURcvdCount;
	int MPDUInRcvdAMPDUCount;
	long RcvdOctetsInAMPDUCount;
	int AMPDUDelmtrCRCErrorCount;
	int ImpBARFailureCount;
	int ExpBARFailureCount;
	int ChannelWidthSwitchCount;
	int TwentyMHzTransFrameCount;
	int FortyMHzTransFrameCount;
	int TwentyMHzRcvdFrameCount;
	int FortyMHzRcvdFrameCount;
	int PSMPSuccessCount;
	int PSMPFailureCount;
	int GrantedRDGUsedCount;
	int GrantedRDGUnusedCount;
	int TransFramesInGrantedRDGCount;
	long TransOctetsInGrantedRDGCount;
	int DualCTSSuccessCount;
	int DualCTSFailureCount;
	
}cntTbl_data;

cntTbl_data *cntTbl_node;
list_T cntList;

void loadcntList(list_T *cntList,int skfd,char * ifName);
cntTbl_data* cntList_get(list_T *cntList,int index,int exact);



/*dot11QAPEDCATable data Structures*/

typedef struct qaTbl_data {
	
	int ifIndex;	
	int QAPEDCATableIndex;
	int QAPEDCATableCWmin;
	int QAPEDCATableCWmax;
	int QAPEDCATableAIFSN;
	int QAPEDCATableTXOPLmt;
	int QAPEDCATableMSDULtime;
	int QAPEDCATableMandatory;
}qaTbl_data;

qaTbl_data *qaTbl_node;
list_T qaList;

void loadqaList(list_T *qaList,int skfd,char * ifName);
qaTbl_data* qaList_get(list_T *qaList,int ifIndex,int qIndex,int exact);


/*QosCountersTable data Structures*/
typedef struct qcTbl_data {
	
	int ifIndex;
	int QosCountersIndex;
	int QosTransFragCount;
	int QosFailedCount;
	int QosRetryCount;
	int QosMultiRetryCount;
	int QosFrameDupCount;
	int QosRTSSuccCount;
	int QosRTSFailCount;
	int QosACKFailCount;
	int QosRcvdFragCount;
	int QosTransFrameCount;
	int QosDiscardedFrameCount;
	int QosMPDUsRcvdCount;
	int QosRetriesRcvdCount;
}qcTbl_data;

qcTbl_data *qcTbl_node;
list_T qcList;

void loadqcList(list_T *qcList,int skfd,char * ifName);
qcTbl_data* qcList_get(list_T *qcList,int ifIndex,int qIndex,int exact);
#endif
